]> Sergey Matveev's repositories - public-inbox.git/blob - examples/grok-pull.post_update_hook.sh
treewide: run update-copyrights from gnulib for 2019
[public-inbox.git] / examples / grok-pull.post_update_hook.sh
1 #!/bin/sh
2 # post_update_hook for repos.conf as used by grok-pull, takes a full
3 # git repo path as it's first and only arg.
4 full_git_dir="$1"
5
6 # same default as other public-inbox-* tools
7 PI_CONFIG=${PI_CONFIG-~/.public-inbox/config}
8
9 # FreeBSD expr(1) only supports BRE, so no '+'
10 EPOCH2MAIN='\(..*\)/git/[0-9][0-9]*\.git'
11
12 # see if it's v2 or v1 based on tree contents, since somebody could
13 # theoretically name a v1 inbox with a path that looks like a v2 epoch
14 if git --git-dir="$full_git_dir" ls-tree --name-only HEAD | \
15         grep -E '^(m|d)$' >/dev/null
16 then
17         inbox_fmt=2
18         inbox_dir=$(expr "$full_git_dir" : "$EPOCH2MAIN")
19         inbox_name=$(basename "$inbox_dir")
20         msgmap="$inbox_dir"/msgmap.sqlite3
21 else
22         inbox_fmt=1
23         inbox_dir="$full_git_dir"
24         inbox_name=$(basename "$inbox_dir" .git)
25         msgmap="$inbox_dir"/public-inbox/msgmap.sqlite3
26 fi
27
28 # run public-inbox-init iff unconfigured
29 cfg_dir=$(git config -f "$PI_CONFIG" publicinbox."$inbox_name".inboxdir)
30
31 # check legacy name for "inboxdir"
32 case $cfg_dir in
33 '') cfg_dir=$(git config -f "$PI_CONFIG" publicinbox."$inbox_name".mainrepo) ;;
34 esac
35
36 case $cfg_dir in
37 '')
38         remote_git_url=$(git --git-dir="$full_git_dir" config remote.origin.url)
39         case $remote_git_url in
40         '')
41                 echo >&2 "remote.origin.url unset in $full_git_dir/config"
42                 exit 1
43                 ;;
44         esac
45
46         case $inbox_fmt in
47         1)
48                 remote_inbox_url="$remote_git_url"
49                 ;;
50         2)
51                 remote_inbox_url=$(expr "$remote_git_url" : "$EPOCH2MAIN")
52                 ;;
53         esac
54
55         config_url="$remote_inbox_url"/_/text/config/raw
56         remote_config="$inbox_dir"/remote.config.$$
57         trap 'rm -f "$remote_config"' EXIT
58         if curl --compressed -sSf -v "$config_url" >"$remote_config"
59         then
60                 # n.b. inbox_name on the remote may not match our local
61                 # inbox_name, so we match all addresses in the remote config
62                 addresses=$(git config -f "$remote_config" -l | \
63                         sed -ne 's/^publicinbox\..\+\.address=//p')
64                 case $addresses in
65                 '')
66                         echo >&2 'unable to extract address(es) from ' \
67                                 "$remote_config"
68                         exit 1
69                         ;;
70                 esac
71                 newsgroups=$(git config -f "$remote_config" -l | \
72                         sed -ne 's/^publicinbox\..\+\.newsgroup=//p')
73         else
74                 newsgroups=
75                 addresses="$inbox_name@$$.$(hostname).example.com"
76                 echo >&2 "E: curl $config_url failed"
77                 echo >&2 "E: using bogus <$addresses> for $inbox_dir"
78         fi
79         local_url="http://127.0.0.1:8080/$inbox_name"
80         public-inbox-init -V$inbox_fmt "$inbox_name" \
81                 "$inbox_dir" "$local_url" $addresses
82
83         if test $? -ne 0
84         then
85                 echo >&2 "E: public-inbox-init failed on $inbox_dir"
86                 exit 1
87         fi
88
89         for ng in $newsgroups
90         do
91                 git config -f "$PI_CONFIG" \
92                         "publicinbox.$inbox_name.newsgroup" "$ng"
93                 # only one newsgroup per inbox
94                 break
95         done
96         echo "I: $inbox_name at $inbox_dir ($addresses) $local_url"
97         ;;
98 esac
99
100 # only run public-inbox-index if an index exists and has messages,
101 # since epochs may be cloned out-of-order by grokmirror and we also
102 # don't know what indexlevel a user wants
103 if test -f "$msgmap"
104 then
105         n=$(echo 'SELECT COUNT(*) FROM msgmap' | sqlite3 -readonly "$msgmap")
106         case $n in
107         0|'')
108                 : v2 inboxes may be init-ed with an empty msgmap
109                 ;;
110         *)
111                 $EATMYDATA public-inbox-index -v "$inbox_dir"
112                 ;;
113         esac
114 fi